Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -1619,211 +1673,230 @@
 
 
-   SUBROUTINE pmci_define_loglaw_correction_parameters( lc, lcr, k, ij, inc, wall_index, z0_l, kb, direction, ncorr )
-      IMPLICIT NONE
-      INTEGER(iwp), INTENT(IN)  ::  direction                 !:
-      INTEGER(iwp), INTENT(IN)  ::  ij                        !:
-      INTEGER(iwp), INTENT(IN)  ::  inc                       !:
-      INTEGER(iwp), INTENT(IN)  ::  k                         !:
-      INTEGER(iwp), INTENT(IN)  ::  kb                        !:
-      INTEGER(iwp), INTENT(OUT) ::  lc                        !:
-      INTEGER(iwp), INTENT(IN)  ::  ncorr                     !:
-      INTEGER(iwp), INTENT(IN)  ::  wall_index                !:
-      REAL(wp), DIMENSION(0:ncorr-1), INTENT(OUT) ::  lcr     !:
-      REAL(wp), INTENT(IN)      ::  z0_l                      !:
+    SUBROUTINE pmci_define_loglaw_correction_parameters( lc, lcr, k, ij, inc,  &
+                                        wall_index, z0_l, kb, direction, ncorr )
+
+       IMPLICIT NONE
+
+       INTEGER(iwp), INTENT(IN)  ::  direction                 !:
+       INTEGER(iwp), INTENT(IN)  ::  ij                        !:
+       INTEGER(iwp), INTENT(IN)  ::  inc                       !:
+       INTEGER(iwp), INTENT(IN)  ::  k                         !:
+       INTEGER(iwp), INTENT(IN)  ::  kb                        !:
+       INTEGER(iwp), INTENT(OUT) ::  lc                        !:
+       INTEGER(iwp), INTENT(IN)  ::  ncorr                     !:
+       INTEGER(iwp), INTENT(IN)  ::  wall_index                !:
+
+       INTEGER(iwp) ::  alcorr       !:
+       INTEGER(iwp) ::  corr_index   !:
+       INTEGER(iwp) ::  lcorr        !:
+
+       LOGICAL      ::  more         !:
+
+       REAL(wp), DIMENSION(0:ncorr-1), INTENT(OUT) ::  lcr     !:
+       REAL(wp), INTENT(IN)      ::  z0_l                      !:
       
-      INTEGER(iwp) ::  alcorr       !:
-      INTEGER(iwp) ::  corr_index   !:
-      INTEGER(iwp) ::  lcorr        !:
-      REAL(wp)     ::  logvelc1     !:
-      LOGICAL      ::  more         !:
+       REAL(wp)     ::  logvelc1     !:
       
 
-      SELECT CASE ( direction )
-
-         CASE (1)   !  k
-            more = .TRUE.
-            lcorr = 0
-            DO  WHILE ( more .AND. lcorr <= ncorr - 1 )
-               corr_index = k + lcorr 
-               IF ( lcorr == 0 )  THEN
-                  CALL pmci_find_logc_pivot_k( lc, logvelc1, z0_l, kb )
-               ENDIF
+       SELECT CASE ( direction )
+
+          CASE (1)   !  k
+             more = .TRUE.
+             lcorr = 0
+             DO  WHILE ( more .AND. lcorr <= ncorr-1 )
+                corr_index = k + lcorr
+                IF ( lcorr == 0 )  THEN
+                   CALL pmci_find_logc_pivot_k( lc, logvelc1, z0_l, kb )
+                ENDIF
                
-               IF ( corr_index < lc )  THEN
-                  lcr(lcorr) = LOG( ( zu(k) - zw(kb) ) / z0_l ) / logvelc1
-                  more = .TRUE.
-               ELSE
-                  lcr(lcorr) = 1.0
-                  more = .FALSE.
-               ENDIF
-               lcorr = lcorr + 1              
-            ENDDO
-
-         CASE (2)   !  j 
-            more = .TRUE.
-            lcorr  = 0
-            alcorr = 0
-            DO  WHILE ( more  .AND.  alcorr <= ncorr - 1 )
-               corr_index = ij + lcorr   !  In this case (direction = 2) ij is j
-               IF ( lcorr == 0 )  THEN
-                  CALL pmci_find_logc_pivot_j( lc, logvelc1, ij, wall_index, z0_l, inc )
-               ENDIF
-
-!
-!--            The role of inc here is to make the comparison operation "<" valid in both directions.
-               IF ( inc * corr_index < inc * lc )  THEN 
-                  lcr(alcorr) = LOG( ABS( coord_y(corr_index) + 0.5_wp * dy  &
-                              - coord_y(wall_index) ) / z0_l ) / logvelc1
-                  more = .TRUE.
-               ELSE
-                  lcr(alcorr) = 1.0_wp
-                  more = .FALSE.
-               ENDIF
-               lcorr  = lcorr + inc
-               alcorr = ABS( lcorr )
-            ENDDO
-
-         CASE (3)   !  i          
-            more = .TRUE.
-            lcorr  = 0
-            alcorr = 0
-            DO  WHILE ( more  .AND.  alcorr <= ncorr - 1 )
-               corr_index = ij + lcorr   !  In this case (direction = 3) ij is i
-               IF ( lcorr == 0 )  THEN
-                  CALL pmci_find_logc_pivot_i( lc, logvelc1, ij, wall_index, z0_l, inc )
-               ENDIF
-
-!
-!--            The role of inc here is to make the comparison operation "<" valid in both directions.
-               IF ( inc * corr_index < inc * lc )  THEN 
-                  lcr(alcorr) = LOG( ABS( coord_x(corr_index) + 0.5_wp * dx &
-                       - coord_x(wall_index) ) / z0_l ) / logvelc1
-                  more = .TRUE.
-               ELSE
-                  lcr(alcorr) = 1.0_wp
-                  more = .FALSE.
-               ENDIF
-               lcorr  = lcorr + inc
-               alcorr = ABS( lcorr )
-            ENDDO
- 
-      END SELECT
-
-   END SUBROUTINE pmci_define_loglaw_correction_parameters
-
-
-
-   SUBROUTINE pmci_find_logc_pivot_k( lc, logzc1, z0_l, kb )
-
-!
-!--   Finds the pivot node and te log-law factor for near-wall nodes for 
-!--   which the wall-parallel velocity components will be log-law corrected 
-!--   after interpolation. This subroutine is only for horizontal walls.
-!
-!--                               Antti Hellsten 30.12.2015
-      IMPLICIT NONE
-      REAL(wp),INTENT(OUT)  ::  logzc1     !:
-      REAL(wp), INTENT(IN)  ::  z0_l       !:
-      INTEGER(iwp), INTENT(IN)    ::  kb   !:
-      INTEGER(iwp), INTENT(OUT)   ::  lc   !:
+                IF ( corr_index < lc )  THEN
+                   lcr(lcorr) = LOG( ( zu(k) - zw(kb) ) / z0_l ) / logvelc1
+                   more = .TRUE.
+                ELSE
+                   lcr(lcorr) = 1.0
+                   more = .FALSE.
+                ENDIF
+                lcorr = lcorr + 1
+             ENDDO
+
+          CASE (2)   !  j
+             more = .TRUE.
+             lcorr  = 0
+             alcorr = 0
+             DO  WHILE ( more  .AND.  alcorr <= ncorr-1 )
+                corr_index = ij + lcorr   ! In this case (direction = 2) ij is j
+                IF ( lcorr == 0 )  THEN
+                   CALL pmci_find_logc_pivot_j( lc, logvelc1, ij, wall_index,  &
+                                                z0_l, inc )
+                ENDIF
+
+!
+!--             The role of inc here is to make the comparison operation "<"
+!--             valid in both directions
+                IF ( inc * corr_index < inc * lc )  THEN
+                   lcr(alcorr) = LOG( ABS( coord_y(corr_index) + 0.5_wp * dy   &
+                                         - coord_y(wall_index) ) / z0_l )      &
+                                 / logvelc1
+                   more = .TRUE.
+                ELSE
+                   lcr(alcorr) = 1.0_wp
+                   more = .FALSE.
+                ENDIF
+                lcorr  = lcorr + inc
+                alcorr = ABS( lcorr )
+             ENDDO
+
+          CASE (3)   !  i
+             more = .TRUE.
+             lcorr  = 0
+             alcorr = 0
+             DO  WHILE ( more  .AND.  alcorr <= ncorr-1 )
+                corr_index = ij + lcorr   ! In this case (direction = 3) ij is i
+                IF ( lcorr == 0 )  THEN
+                   CALL pmci_find_logc_pivot_i( lc, logvelc1, ij, wall_index,  &
+                                                z0_l, inc )
+                ENDIF
+!
+!--             The role of inc here is to make the comparison operation "<"
+!--             valid in both directions
+                IF ( inc * corr_index < inc * lc )  THEN
+                   lcr(alcorr) = LOG( ABS( coord_x(corr_index) + 0.5_wp * dx   &
+                                         - coord_x(wall_index) ) / z0_l )      &
+                                 / logvelc1
+                   more = .TRUE.
+                ELSE
+                   lcr(alcorr) = 1.0_wp
+                   more = .FALSE.
+                ENDIF
+                lcorr  = lcorr + inc
+                alcorr = ABS( lcorr )
+             ENDDO
+
+       END SELECT
+
+    END SUBROUTINE pmci_define_loglaw_correction_parameters
+
+
+
+    SUBROUTINE pmci_find_logc_pivot_k( lc, logzc1, z0_l, kb )
+!
+!--    Finds the pivot node and te log-law factor for near-wall nodes for
+!--    which the wall-parallel velocity components will be log-law corrected
+!--    after interpolation. This subroutine is only for horizontal walls.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp), INTENT(IN)  ::  kb   !:
+       INTEGER(iwp), INTENT(OUT) ::  lc   !:
+
+       INTEGER(iwp) ::  kbc    !:
+       INTEGER(iwp) ::  k1     !:
+
+       REAL(wp),INTENT(OUT) ::  logzc1     !:
+       REAL(wp), INTENT(IN) ::  z0_l       !:
+
+       REAL(wp) ::  zuc1   !:
+
+
+       kbc = nzb + 1
+!
+!--    kbc is the first coarse-grid point above the surface
+       DO  WHILE ( cg%zu(kbc) < zu(kb) )
+          kbc = kbc + 1
+       ENDDO
+       zuc1  = cg%zu(kbc)
+       k1    = kb + 1
+       DO  WHILE ( zu(k1) < zuc1 )  !  Important: must be <, not <=
+          k1 = k1 + 1
+       ENDDO
+       logzc1 = LOG( (zu(k1) - zw(kb) ) / z0_l )
+       lc = k1
+
+    END SUBROUTINE pmci_find_logc_pivot_k
+
+
+
+    SUBROUTINE pmci_find_logc_pivot_j( lc, logyc1, j, jw, z0_l, inc )
+!
+!--    Finds the pivot node and te log-law factor for near-wall nodes for
+!--    which the wall-parallel velocity components will be log-law corrected
+!--    after interpolation. This subroutine is only for vertical walls on
+!--    south/north sides of the node.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp), INTENT(IN)  ::  inc    !:  increment must be 1 or -1.
+       INTEGER(iwp), INTENT(IN)  ::  j      !:
+       INTEGER(iwp), INTENT(IN)  ::  jw     !:
+       INTEGER(iwp), INTENT(OUT) ::  lc     !:
+
+       INTEGER(iwp) ::  j1       !:
+
+       REAL(wp), INTENT(IN) ::  z0_l   !:
+
+       REAL(wp) ::  logyc1   !:
+       REAL(wp) ::  yc1      !:
+
+!
+!--    yc1 is the y-coordinate of the first coarse-grid u- and w-nodes out from
+!--    the wall
+       yc1  = coord_y(jw) + 0.5_wp * inc * cg%dy
+!
+!--    j1 is the first fine-grid index further away from the wall than yc1
+       j1 = j
+!
+!--    Important: must be <, not <=
+       DO  WHILE ( inc * ( coord_y(j1) + 0.5_wp * dy ) < inc * yc1 )
+          j1 = j1 + inc
+       ENDDO
+
+       logyc1 = LOG( ABS( coord_y(j1) + 0.5_wp * dy - coord_y(jw) ) / z0_l )
+       lc = j1
+
+    END SUBROUTINE pmci_find_logc_pivot_j
+
+
+
+    SUBROUTINE pmci_find_logc_pivot_i( lc, logxc1, i, iw, z0_l, inc )
+!
+!--    Finds the pivot node and the log-law factor for near-wall nodes for
+!--    which the wall-parallel velocity components will be log-law corrected
+!--    after interpolation. This subroutine is only for vertical walls on
+!--    south/north sides of the node.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp), INTENT(IN)  ::  i      !:
+       INTEGER(iwp), INTENT(IN)  ::  inc    !: increment must be 1 or -1.
+       INTEGER(iwp), INTENT(IN)  ::  iw     !:
+       INTEGER(iwp), INTENT(OUT) ::  lc     !:
+
+       INTEGER(iwp) ::  i1       !:
+
+       REAL(wp), INTENT(IN) ::  z0_l   !:
+
+       REAL(wp) ::  logxc1   !:
+       REAL(wp) ::  xc1      !:
+
+!
+!--    xc1 is the x-coordinate of the first coarse-grid v- and w-nodes out from
+!--    the wall
+       xc1  = coord_x(iw) + 0.5_wp * inc * cg%dx
+!
+!--    i1 is the first fine-grid index futher away from the wall than xc1.
+       i1 = i
+!
+!--    Important: must be <, not <=
+       DO  WHILE ( inc * ( coord_x(i1) + 0.5_wp *dx ) < inc * xc1 )
+          i1 = i1 + inc
+       ENDDO
       
-      REAL(wp)     ::  zuc1   !:
-      INTEGER(iwp) ::  kbc    !:
-      INTEGER(iwp) ::  k1     !:
-
-
-      kbc = nzb + 1
-      DO  WHILE ( cg%zu(kbc) < zu(kb) )   !  kbc is the first coarse-grid point above the surface.
-         kbc = kbc + 1
-      ENDDO
-      zuc1  = cg%zu(kbc)
-      k1    = kb + 1  
-      DO  WHILE ( zu(k1) < zuc1 )         !  Important: must be <, not <=
-         k1 = k1 + 1
-      ENDDO
-      logzc1 = LOG( (zu(k1) - zw(kb) ) / z0_l )
-      lc = k1
-
-   END SUBROUTINE pmci_find_logc_pivot_k
-
-
-
-   SUBROUTINE pmci_find_logc_pivot_j( lc, logyc1, j, jw, z0_l, inc )
-
-!
-!--   Finds the pivot node and te log-law factor for near-wall nodes for 
-!--   which the wall-parallel velocity components will be log-law corrected 
-!--   after interpolation. This subroutine is only for vertical walls on 
-!--   south/north sides of the node.
-!
-!--                               Antti Hellsten 5.1.2016
-      IMPLICIT NONE
-      REAL(wp), INTENT(IN)      ::  z0_l   !:
-      INTEGER(iwp), INTENT(IN)  ::  inc    !:  increment must be 1 or -1.
-      INTEGER(iwp), INTENT(IN)  ::  j      !:
-      INTEGER(iwp), INTENT(IN)  ::  jw     !:
-      INTEGER(iwp), INTENT(OUT) ::  lc     !:
-      
-      REAL(wp)     ::  logyc1   !:
-      REAL(wp)     ::  yc1      !:
-      INTEGER(iwp) ::  j1       !:
-
-!
-!--   yc1 is the y-coordinate of the first coarse-grid u- and w-nodes out from the wall.
-      yc1  = coord_y(jw) + 0.5_wp * inc * cg%dy  
-
-!
-!--   j1 is the first fine-grid index futher away from the wall than yc1.
-      j1 = j   
-      DO  WHILE ( inc * ( coord_y(j1) + 0.5_wp * dy ) < inc * yc1 )   !  Important: must be <, not <=
-         j1 = j1 + inc
-      ENDDO
-
-      logyc1 = LOG( ABS( coord_y(j1) + 0.5_wp * dy - coord_y(jw) ) / z0_l )
-      lc = j1
-
-   END SUBROUTINE pmci_find_logc_pivot_j
-
-
-
-   SUBROUTINE pmci_find_logc_pivot_i( lc, logxc1, i, iw, z0_l, inc )
-
-!
-!--   Finds the pivot node and the log-law factor for near-wall nodes for 
-!--   which the wall-parallel velocity components will be log-law corrected 
-!--   after interpolation. This subroutine is only for vertical walls on 
-!--   south/north sides of the node.
-!
-!--                               Antti Hellsten 8.1.2016
-
-      IMPLICIT NONE
-      REAL(wp), INTENT(IN)      ::  z0_l   !:
-      INTEGER(iwp), INTENT(IN)  ::  i      !:
-      INTEGER(iwp), INTENT(IN)  ::  inc    !: increment must be 1 or -1.
-      INTEGER(iwp), INTENT(IN)  ::  iw     !:
-      INTEGER(iwp), INTENT(OUT) ::  lc     !:
-
-      REAL(wp)     ::  logxc1   !:
-      REAL(wp)     ::  xc1      !:
-      INTEGER(iwp) ::  i1       !:
-
-!
-!--   xc1 is the x-coordinate of the first coarse-grid v- and w-nodes out from the wall.
-      xc1  = coord_x(iw) + 0.5_wp *inc * cg%dx  
-
-!
-!--   i1 is the first fine-grid index futher away from the wall than xc1.
-      i1 = i   
-      DO  WHILE ( inc * ( coord_x(i1) + 0.5_wp *dx ) < inc *xc1 )   !  Important: must be <, not <=
-         i1 = i1 + inc
-      ENDDO
-      
-      logxc1 = LOG( ABS( coord_x(i1) + 0.5_wp*dx - coord_x(iw) ) / z0_l )
-      lc = i1
-
-   END SUBROUTINE pmci_find_logc_pivot_i
-
-
-
+       logxc1 = LOG( ABS( coord_x(i1) + 0.5_wp*dx - coord_x(iw) ) / z0_l )
+       lc = i1
+
+    END SUBROUTINE pmci_find_logc_pivot_i
+
+
+!-- TO_DO:  indentation and wrap long lines from here on to the end of the file
    SUBROUTINE pmci_init_anterp_tophat
 !
@@ -1831,20 +1904,21 @@
 !--   corresponding coarse-grid array index and the 
 !--   Under-relaxation coefficients to be used by anterp_tophat.
-!
-!--                               Antti Hellsten 9.10.2015.
+
       IMPLICIT NONE
-      INTEGER(iwp) ::  i        !:
+
+      INTEGER(iwp) ::  i        !: Fine-grid index
+      INTEGER(iwp) ::  ii       !: Coarse-grid index
       INTEGER(iwp) ::  istart   !:
-      INTEGER(iwp) ::  j        !:
+      INTEGER(iwp) ::  j        !: Fine-grid index
+      INTEGER(iwp) ::  jj       !: Coarse-grid index
       INTEGER(iwp) ::  jstart   !:
-      INTEGER(iwp) ::  k        !:
+      INTEGER(iwp) ::  k        !: Fine-grid index
+      INTEGER(iwp) ::  kk       !: Coarse-grid index
       INTEGER(iwp) ::  kstart   !:
-      INTEGER(iwp) ::  l        !:
-      INTEGER(iwp) ::  m        !:
-      INTEGER(iwp) ::  n        !:
       REAL(wp)     ::  xi       !:
       REAL(wp)     ::  eta      !:
       REAL(wp)     ::  zeta     !:
      
+
 !
 !--   Default values:
@@ -1866,16 +1940,16 @@
 
 !
-!--   First determine kceu and kcew that are the coarse-grid upper bounds for index k.
-      n = 0
-      DO  WHILE ( cg%zu(n) < zu(nzt) )
-         n = n + 1
+!--   First determine kctu and kctw that are the coarse-grid upper bounds for index k.
+      kk = 0
+      DO  WHILE ( cg%zu(kk) < zu(nzt) )
+         kk = kk + 1
       ENDDO
-      kceu = n - 1 
-
-      n = 0
-      DO  WHILE ( cg%zw(n) < zw(nzt-1) )
-         n = n + 1
+      kctu = kk - 1 
+
+      kk = 0
+      DO  WHILE ( cg%zw(kk) < zw(nzt-1) )
+         kk = kk + 1
       ENDDO
-      kcew = n - 1 
+      kctw = kk - 1 
 
       ALLOCATE( iflu(icl:icr) )
@@ -1887,23 +1961,23 @@
       ALLOCATE( jfuv(jcs:jcn) )
       ALLOCATE( jfuo(jcs:jcn) )
-      ALLOCATE( kflw(0:kcew) )
-      ALLOCATE( kflo(0:kceu) )
-      ALLOCATE( kfuw(0:kcew) )
-      ALLOCATE( kfuo(0:kceu) )
+      ALLOCATE( kflw(0:kctw) )
+      ALLOCATE( kflo(0:kctu) )
+      ALLOCATE( kfuw(0:kctw) )
+      ALLOCATE( kfuo(0:kctu) )
 
 !
 !--   i-indices of u for each l-index value.    
       istart = nxlg
-      DO  l = icl, icr  
+      DO  ii = icl, icr  
          i = istart
-         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(l) - 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
+         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
             i = i + 1
          ENDDO
-         iflu(l) = MIN( MAX( i, nxlg ), nxrg )
-         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(l) + 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
+         iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
+         DO  WHILE ( ( coord_x(i)  <  cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.  ( i < nxrg ) ) 
             i = i + 1
          ENDDO
-         ifuu(l) = MIN( MAX( i, nxlg ), nxrg )
-         istart = iflu(l)
+         ifuu(ii) = MIN( MAX( i, nxlg ), nxrg )
+         istart = iflu(ii)
       ENDDO
 
@@ -1911,15 +1985,15 @@
 !--   i-indices of others for each l-index value.
       istart = nxlg
-      DO  l = icl, icr   
+      DO  ii = icl, icr   
          i = istart
-         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(l) )  .AND.  ( i < nxrg ) ) 
+         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(ii) )  .AND.  ( i < nxrg ) ) 
             i = i + 1
          ENDDO
-         iflo(l) = MIN( MAX( i, nxlg ), nxrg )
-         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(l) + cg%dx )  .AND.  ( i < nxrg ) ) 
+         iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
+         DO  WHILE ( ( coord_x(i) + 0.5_wp * dx  <  cg%coord_x(ii) + cg%dx )  .AND.  ( i < nxrg ) ) 
             i = i + 1
          ENDDO
-         ifuo(l) = MIN(MAX(i,nxlg),nxrg)
-         istart = iflo(l)
+         ifuo(ii) = MIN(MAX(i,nxlg),nxrg)
+         istart = iflo(ii)
       ENDDO
 
@@ -1927,15 +2001,15 @@
 !--   j-indices of v for each m-index value.
       jstart = nysg
-      DO  m = jcs, jcn
+      DO  jj = jcs, jcn
          j = jstart
-         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(m) - 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
+         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
             j = j + 1
          ENDDO
-         jflv(m) = MIN( MAX( j, nysg ), nyng ) 
-         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(m) + 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
+         jflv(jj) = MIN( MAX( j, nysg ), nyng ) 
+         DO  WHILE ( ( coord_y(j)  <  cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.  ( j < nyng ) ) 
             j = j + 1
          ENDDO
-         jfuv(m) = MIN( MAX( j, nysg ), nyng )
-         jstart = jflv(m)
+         jfuv(jj) = MIN( MAX( j, nysg ), nyng )
+         jstart = jflv(jj)
       ENDDO
 
@@ -1943,15 +2017,15 @@
 !--   j-indices of others for each m-index value.
       jstart = nysg
-      DO  m = jcs, jcn
+      DO  jj = jcs, jcn
          j = jstart
-         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(m) )  .AND.  ( j < nyng ) )  
+         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(jj) )  .AND.  ( j < nyng ) )  
             j = j + 1
          ENDDO
-         jflo(m) = MIN( MAX( j, nysg ), nyng )
-         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(m) + cg%dy )  .AND.  ( j < nyng ) ) 
+         jflo(jj) = MIN( MAX( j, nysg ), nyng )
+         DO  WHILE ( ( coord_y(j) + 0.5_wp * dy  <  cg%coord_y(jj) + cg%dy )  .AND.  ( j < nyng ) ) 
             j = j + 1
          ENDDO
-         jfuo(m) = MIN( MAX( j, nysg ), nyng )
-         jstart = jflv(m)
+         jfuo(jj) = MIN( MAX( j, nysg ), nyng )
+         jstart = jflv(jj)
       ENDDO
 
@@ -1961,15 +2035,15 @@
       kflw(0) = 0
       kfuw(0) = 0
-      DO  n = 1, kcew
+      DO  kk = 1, kctw
          k = kstart
-         DO  WHILE ( ( zw(k) < cg%zw(n) - 0.5_wp * cg%dzw(n) )  .AND.  ( k < nzt ) ) 
+         DO  WHILE ( ( zw(k) < cg%zw(kk) - 0.5_wp * cg%dzw(kk) )  .AND.  ( k < nzt ) ) 
             k = k + 1
          ENDDO
-         kflw(n) = MIN( MAX( k, 1 ), nzt + 1 )
-         DO  WHILE ( ( zw(k) < cg%zw(n) + 0.5_wp * cg%dzw(n+1) )  .AND.  ( k < nzt ) ) 
+         kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+         DO  WHILE ( ( zw(k) < cg%zw(kk) + 0.5_wp * cg%dzw(kk+1) )  .AND.  ( k < nzt ) ) 
             k = k + 1
          ENDDO
-         kfuw(n) = MIN( MAX( k, 1 ), nzt + 1 )
-         kstart = kflw(n)
+         kfuw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+         kstart = kflw(kk)
       ENDDO
 
@@ -1979,15 +2053,15 @@
       kflo(0) = 0
       kfuo(0) = 0
-      DO  n = 1, kceu
+      DO  kk = 1, kctu
          k = kstart
-         DO  WHILE ( ( zu(k) < cg%zu(n) - 0.5_wp * cg%dzu(n) )  .AND.  ( k < nzt ) ) 
+         DO  WHILE ( ( zu(k) < cg%zu(kk) - 0.5_wp * cg%dzu(kk) )  .AND.  ( k < nzt ) ) 
             k = k + 1
          ENDDO
-         kflo(n) = MIN( MAX( k, 1 ), nzt + 1 )
-         DO  WHILE ( ( zu(k) < cg%zu(n) + 0.5_wp * cg%dzu(n+1) )  .AND.  ( k < nzt ) )  
+         kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
+         DO  WHILE ( ( zu(k) < cg%zu(kk) + 0.5_wp * cg%dzu(kk+1) )  .AND.  ( k < nzt ) )  
             k = k + 1
          ENDDO
-         kfuo(n) = MIN( MAX( k-1, 1 ), nzt + 1 )
-         kstart = kflo(n)
+         kfuo(kk) = MIN( MAX( k-1, 1 ), nzt + 1 )
+         kstart = kflo(kk)
       ENDDO
      
@@ -1995,31 +2069,33 @@
 !--   Spatial under-relaxation coefficients
       ALLOCATE( frax(icl:icr) )
-      DO  l = icl, icr
+
+      DO  ii = icl, icr
          IF ( nest_bound_l ) THEN
-            xi   = ( ( cg%coord_x(l) - lower_left_coord_x ) / anterp_relax_length_l )**4
+            xi   = ( MAX( 0.0_wp, ( cg%coord_x(ii) - lower_left_coord_x ) ) / anterp_relax_length_l )**4
          ELSEIF ( nest_bound_r ) THEN
-            xi   = ( ( lower_left_coord_x + ( nx + 1 ) * dx - cg%coord_x(l) ) / anterp_relax_length_r )**4
+            xi   = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx - cg%coord_x(ii) ) ) / anterp_relax_length_r )**4
          ELSE
             xi   = 999999.9_wp
          ENDIF
-         frax(l)  = xi / ( 1.0_wp + xi )
+         frax(ii)  = xi / ( 1.0_wp + xi )
       ENDDO
 
       ALLOCATE( fray(jcs:jcn) )
-      DO  m = jcs, jcn
+
+      DO  jj = jcs, jcn
          IF ( nest_bound_s ) THEN           
-            eta  = ( ( cg%coord_y(m) - lower_left_coord_y ) / anterp_relax_length_s )**4
+            eta  = ( MAX( 0.0_wp, ( cg%coord_y(jj) - lower_left_coord_y ) ) / anterp_relax_length_s )**4
          ELSEIF ( nest_bound_n ) THEN
-            eta  = ( (lower_left_coord_y + ( ny + 1 ) * dy - cg%coord_y(m)) / anterp_relax_length_n )**4
+            eta  = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy - cg%coord_y(jj)) ) / anterp_relax_length_n )**4
          ELSE
             eta  = 999999.9_wp
          ENDIF
-         fray(m)  = eta / ( 1.0_wp + eta )
+         fray(jj)  = eta / ( 1.0_wp + eta )
       ENDDO
       
-      ALLOCATE( fraz(0:kceu) )
-      DO  n = 0, kceu        
-         zeta = ( ( zu(nzt) - cg%zu(n) ) / anterp_relax_length_t )**4       
-         fraz(n) = zeta / ( 1.0_wp + zeta )
+      ALLOCATE( fraz(0:kctu) )
+      DO  kk = 0, kctu        
+         zeta = ( ( zu(nzt) - cg%zu(kk) ) / anterp_relax_length_t )**4       
+         fraz(kk) = zeta / ( 1.0_wp + zeta )
       ENDDO
 
